# Antidote-CIS

> Use Open Standards, Open Data, Open Source, and Open Innovation. 

This project includes a simple, cross-platform, portable CIS client. may also include a modified `smbd` (samba server) to upload package to CIS. 

This project aims to make CIS development experience easier. 

Designed for linux, can 100% run on windows and macOS, but not tested. You should collect all dependencies on your own. 

## Dependency

All these dependencies are confirmed to support Linux (natively), WSL (natively), and win32 (Use your google to find smbclient for win32). 
These dependencies could also be found on BSD, MacOS, and any OS with a working C++ compiler. 

json2table >1.0.2 <https://git.recolic.net/root/json2table>, bash, smbclient <https://wiki.archlinux.org/index.php/samba#Client>, curl, unix binutil (cut,cat,tr,grep,,find,curl).

## Usage

### 1 - Install the script

Just copy `antidote-cis` and `antidote.config.sh` to your PATH. It's usually `/usr/bin/` on linux. 

### 2 - Read and modify config file

Read and modify `antidote.config.sh`. You must set `cis_cookie` and `smb_namespace`, and you may also want to modify `cis_namespace`, `cis_default_workflow_name`, `cis_default_workflow_parameter` to yours. 

If you're familiar to CIS, you should know how to set them.

### 3 - Ready for use

You can upload your package to CIS, and run CIS workflow easily from command line. 

Please run `antidote-cis` to read help message before using. Here're some examples:

```
antidote-cis push path/to/your/workflow.directory BootstrapCAWorkflow v1.5.5
antidote-cis push path/to/your/workflow.directory BootstrapCAWorkflow
antidote-cis push path/to/your/workflow.directory
antidote-cis cloudrun BootstrapCAWorkflow v1.5.5
antidote-cis cloudrun BootstrapCAWorkflow
antidote-cis cloudrun
antidote-cis cloudrun BuildDomainControllerWorkflow MdmId=MDM1001555 IsFirstDC=true UsernameKey=myusername_k PasswordKey="Hi, this is my password!$'"
```

# notes

version number should not contain space. 
workflowname and version number should not contain `=`

only tested on bash > 4.0.0. please report bug if there's problem on bash 3.x. 

This script is only tested within M365FleetAGC team. Please report bug if you realize it not working for you! (Please mailto: bensl@microsoft.com)

smbclient for windows is not working. Possible solution from: http://www.allandynes.com/2016/05/samba-client-for-windows-smbclient-exe-v3-6-25/ , https://recolic.net/blog/post/build-smbclient-for-windows

# TODOs

1. auth
3. re-write with C# (.NET5): upload package, run jobs
2. make it working on all platform (packaging for windows)
4. 
